local Window = require 'objects.obj_window'
local Option_A = Window:extend()

function Option_A:new(x, y, w, h, options)
	Option_A.super.new(self, x, y, w, h)

	self.options = options or {} -- AN ARRAY OF ITEMS
	self.selection = {}
	--SET THE OPTIONS
	if table.getn(self.options) > 0 then
		self.selection[1] = true
		for i = 2, table.getn(self.options) do
			self.selection[i] = false
		end
	end

end

function Option_A:update(dt)
end

function Option_A:draw()
	Option_A.super.draw(self)

	--DRAW ALL THE OPTIONS
	local space_x, space_y = self.x + 8, self.y + 16
	for i = 1, table.getn(self.options) do
		if self.selection[i] == true then
			love.graphics.setColor(255,201,14)--(248,216,120)
			love.graphics.print(self.options[i], space_x, space_y)
			love.graphics.setColor(255,255,255)
		else
			love.graphics.print(self.options[i], space_x, space_y)
		end
		space_y = space_y + 16
	end
end

--[[
	Finds the option that needs to be highlighted.
	If it doesn't find the right one, it will be set to false (helps switch highlight)
--]]
function Option_A:setSelect(num)
	for i = 1, table.getn(self.options) do
		if i == num then
			self.selection[i] = true
		else
			self.selection[i] = false
		end
	end
end

return Option_A