local Option_A = require 'objects.obj_option_a'
local TextBox = require 'objects.obj_textBox'

StateOne = {}

function StateOne:init()
end

function StateOne:enter()
	self.option = Option_A(10, 16, 20, 12, {"ATTACK", "DEFENSE", "LUCK"})

	self.howTo = "Z = Confirm, X = Back"
	self.selection = 1 -- WHAT OPTION ARE WE ON NOW? (1 = 'ATTACK', 2 = 'DEFENSE' etc...)
	self.explain = {
		[1] = "Base attack power",
		[2] = "Base defense power",
		[3] = "Chance of crit & item drop",
	}
	self.textBox = TextBox(1, 1, 29, 2)
	self.textBox2 = TextBox(1, 5, 29, 2)
end

function StateOne:update(dt)
end

function StateOne:draw()
	self.textBox:draw(self.howTo)
	self.textBox2:draw(self.explain[self.selection])
	self.option:draw()
	
	printStatOnly(hero, "ATTACK", 11, 18)
	printStatOnly(hero, "DEFENSE", 11, 20)
	printStatOnly(hero, "LUCK", 11, 22)
end

function StateOne:keypressed(key)
	if key == 'down' then
		if self.selection >= table.getn(self.option.options) then -- if we go out of bounds
			self.selection = 1 -- Go to top
		else
			self.selection = self.selection + 1
		end
		self.option:setSelect(self.selection)
	elseif key == 'up' then
		if self.selection <= 1 then -- if we go out of bounds
			self.selection = table.getn(self.option.options) -- Go to bottom
		else
			self.selection = self.selection - 1
		end
		self.option:setSelect(self.selection)
	elseif key == 'z' then
		return self:inputHandler(self.selection)
	elseif key == 'x' then
	end
end

local bindings = {
	--WHAT I WANT
	--[1] = function() Gamestate.push(StateTwo, "ATTACK", 11, 18) end,

	--WHAT WORKS
	[1] = function() Gamestate.push(StateTwo) end,
	--NOTHING HERE YET
	[2] = function() Gamestate.push() end,
	[3] = function() Gamestate.push() end,
}

function StateOne:inputHandler(input)
	local action = bindings[input]
	if action then return action() end
end

function printStatOnly(unit, id, x, y)
	local base = unit:GetBase(id)
	local full = unit:Get(id)
	local space = ""
	for i = 1, string.len(id) do
		space = space .. " "
	end
	local str = string.format("%s %d:%d", space, base, full)
	love.graphics.print(str, x*8, y*8)
end